// bit op.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <stdlib.h>
#include <stdio.h>
#include <memory.h>
#include <stdexcpt.h>
#include <stdexcept>
#include <new>
#include <new.h>
#include <ctype.h>
#include <stdio.h>

unsigned int charToUnInt(char* in_data);
unsigned int setNbit(unsigned int num, int n);
unsigned int getNbit(unsigned int num, int n);
unsigned int unsetNbit(unsigned int num, int n);
unsigned int replaceIJ(unsigned int num, int i, int j);
void printBinary(unsigned int n);
unsigned int replaceIJ(unsigned int num, int i, int j);
void interpreter(char *pch_fin, char *pch_fout);
void Ceazar(char *pch_fin, char *pch_fout, int mode);
void relast(char *pch_fin, char *pch_fout);
void last(char *pch_fin, char *pch_fout);

unsigned int getRightNbits(unsigned int num, int n);
unsigned int getLeftNbits(unsigned int num, int n);

char ch_int(char n);
char re_ch_int(char n);
void binary_operations();

int _tmain(int argc, _TCHAR* argv[])
{
	//binary_operations();
	unsigned int num=400032765;
	printBinary(num);
	printBinary(getLeftNbits(num,4));
	return 0;
//	interpreter("C:\\Users\\Public\\Pictures\\Sample Pictures\\Koala.jpg","encode.txt");
//	interpreter("encode.txt","re_encode.jpg");
//	int code=109;
//	Ceazar("C:\\Users\\Public\\Pictures\\Sample Pictures\\Koala.jpg","ceazar.txt",code);
//	Ceazar("ceazar.txt","receazar.jpg",-1*code);
	last("code.txt","last.txt");
	relast("last.txt","relast.txt");	
	
	last("C:\\Users\\Public\\Pictures\\Sample Pictures\\Koala.jpg","last.txt");
	relast("last.txt","relast.jpg");	

	return 0;
	
}
unsigned int charToUnInt(char* in_data){
	char *p=in_data;
	unsigned int unum=0;
	while(*p&&isdigit(*p)&&(p-in_data<8*sizeof(unsigned int))){
		unum*=2;
		unum+=*p-'0';
		*p++;
	}
	if(*p&&!isdigit(*p)){
		printf("\nError: non-digit symb found\n");
		exit(-2);
	}
	return unum;
}
void printBinary(unsigned int n){
	char *ch_out=NULL;
	int size=sizeof(n)*8;
	ch_out=(char*)malloc((size+1)*sizeof(char));
	char *p=ch_out+size;
	if(!ch_out){
		printf("Error: in cause of memory not found");
		exit(-3);
	}
	unsigned int r=0;
	for(int i=0; i<size; i++){
		r=(n>>i)&1;
		*(ch_out+size-i-1)=r + '0';
	}
	*(ch_out+size)=0;
	printf("[%d:%s]",size,ch_out);
}
unsigned int setNbit(unsigned int num, int n){
	return num|(1<<(n-1));
}
unsigned int getNbit(unsigned int num, int n){
	return (num>>(n-1))&1/*(1<<(n-1))*/;
}
unsigned int unsetNbit(unsigned int num, int n){
	return	num&(~(1<<(n-1)));
			//(num>>(n-1)&1)?(1<<(n-1))^num:num;
}
unsigned int replaceIJ(unsigned int num, int i, int j){
	unsigned int ai, aj;
	ai=getNbit(num,i);
	aj=getNbit(num,j);
	unsigned int res0=(1<<(j-1)) | (1<<(i-1));
	return (num&~res0^((ai<<(j-1)) | (aj<<(i-1))));
}
void interpreter(char *pch_fin, char *pch_fout){
	FILE *fin=NULL, *fout=NULL;
	if(!(fin=fopen(pch_fin,"rb"))){
		printf("AHTUNG!!!!");
		exit(-9);
	}
	fout=fopen(pch_fout,"wb");
	char c;
	char out_c;
	char *p="kukareku";
	char *pp=p;
	int i=0;
	while(!feof(fin)){
		c=fgetc(fin);
		out_c=c^*p++;
		i++;
		if(i==7){p=pp;i=0;}
		//pp=(pp-p==strlen(p));		
		//printf("\n%c:%c\n",c, out_c);
		fprintf(fout,"%c",out_c);
	}
	fclose(fin);
	fclose(fout);
}
void binary_operations(){
	int size=sizeof(unsigned int)*8;
	printf("insert a number(binary %d bit)..",size);
	char *inp=NULL;
	inp=(char*)malloc((size+1)*sizeof(char));
	if(!inp){
		printf("Error: in cause of memory not found");
		exit(-1);
	}
	gets(inp);
	unsigned int out_res=charToUnInt(inp);
	printf("\nOut res== %d\n",out_res);
	printf("\nOut binary..");
	printBinary(out_res);

	int k;
	printf("\n----- insert position for setting bit..\n");
	scanf("%d",&k);
	printf("\n Set n operation(n==%d): ..",k);
	printBinary(setNbit(out_res,k));

	printf("\n\n Num==                   ");
	printBinary(out_res);

	printf("\n----- insert position for unsetting bit..\n");
	scanf("%d",&k);
	printf("\n UnSet operation(n==%d): ..",k);
	printBinary(unsetNbit(out_res,k));

	printf("\n----- insert position for get bit..\n");
	scanf("%d",&k);

	printf("\nGet n bit(n==%d): ..%d\n",k,getNbit(out_res,k));
	printf("\n\n Num==                       ");
	printBinary(out_res);
	int i=0,j=0;
	printf("\n----- insert position [what:with] repclacing bit..\n");
	scanf("%d",&i);
	scanf("%d",&j);

	printf("\nReplace i(%d),j(%d) bits for each other", i,j);
	printBinary(replaceIJ(out_res, i,j));
}

void Ceazar(char *pch_fin, char *pch_fout, int mode){
	FILE *fin=NULL, *fout=NULL;
	fin=fopen(pch_fin,"rb+");
	fout=fopen(pch_fout,"wb");
	char c;
	char out_c;
	//char *p="kukareku";
	
	int i=0;
	while(!feof(fin)){
		c=fgetc(fin);
		if(feof(fin))break;
		out_c=c+mode;
		//pp=(pp-p==strlen(p));		
		//printf("\n%c:%c\n",c, out_c);
		fprintf(fout,"%c",out_c);
	}
	fclose(fin);
	fclose(fout);
}
void last(char *pch_fin, char *pch_fout){
	FILE *fin=NULL, *fout=NULL;
	fin=fopen(pch_fin,"rb+");
	fout=fopen(pch_fout,"wb");
	char c;
	char out_c;
	int i=0;
	while(!feof(fin)){
		c=fgetc(fin);
		if(feof(fin))break;
		char n2=/*c>>4 & 15*/getRightNbits(c,4);
		char n1=getLeftNbits(c,4);
	//	printf("num:[");printBinary(c);printf("]");
	//	printf("n2:[");printBinary(n2);printf("]");
	//	printf("n1:[");printBinary(n1);printf("]");
		//n1=n1>>4;
//		printf("n1:[");printBinary(n1);printf("]\n");
		n2=ch_int(n2);
		n1=ch_int(n1);
    //	printBinary(n2);
	//	printBinary(n1);
		out_c=(n2<<4)&240 | n1;
	//	printBinary(out_c);
	//printBinary((int)c);

		//pp=(pp-p==strlen(p));		
		//printf("\n%c:%c\n",c, out_c);
		fprintf(fout,"%c",out_c);
	}
	fclose(fin);
	fclose(fout);

	
}

void relast(char *pch_fin, char *pch_fout){
	FILE *fin=NULL, *fout=NULL;
	fin=fopen(pch_fin,"rb+");
	fout=fopen(pch_fout,"wb");
	char c;
	char out_c;
	//char *p="kukareku";
	
	int i=0;
	printf("\n\n");
	while(!feof(fin)){
		c=fgetc(fin);
		if(feof(fin))break;
		char n2=c>>4 & 15;
		char n1=c&15;

		n2=re_ch_int(n2);
		n1=re_ch_int(n1);
	//	printf("n2:[");		printBinary(n2);printf("]");
	//	printBinary(n1);

		out_c=(n2<<4)&240 | n1;
	//	printBinary(out_c);
	//	printf("\n\n");
		//printBinary((int)out_c);

		//pp=(pp-p==strlen(p));		
		//printf("\n%c:%c\n",c, out_c);
		fprintf(fout,"%c",out_c);
	}
	fclose(fin);
	fclose(fout);

	
}
char ch_int(char n){
	switch(n){
		case 0:
			return 2;
			break;
		case 1:
			return 10;
			break;
		case 2:
			return 14;
			break;
		case 3:
			return 7;
			break;
		case 4:
			return 8;
			break;
		case 5:
			return 11;
			break;
		case 6:
			return 5;
			break;
		case 7:
			return 13;
			break;
		case 8:
			return 3;
			break;
		case 9:
			return 4;
			break;
		case 10:
			return 0;
			break;
		case 11:
			return 15;
			break;
		case 12:
			return 12;
			break;
		case 13:
			return 1;
			break;
		case 14:
			return 6;
			break;
		case 15:
			return 9;
			break;
	}
}
char re_ch_int(char n){
	switch(n){
		case 2:
			return 0;
			break;
		case 10:
			return 1;
			break;
		case 14:
			return 2;
			break;
		case 7:
			return 3;
			break;
		case 8:
			return 4;
			break;
		case 11:
			return 5;
			break;
		case 5:
			return 6;
			break;
		case 13:
			return 7;
			break;
		case 3:
			return 8;
			break;
		case 4:
			return 9;
			break;
		case 0:
			return 10;
			break;
		case 15:
			return 11;
			break;
		case 12:
			return 12;
			break;
		case 1:
			return 13;
			break;
		case 6:
			return 14;
			break;
		case 9:
			return 15;
			break;
	}
} 
unsigned int getRightNbits(unsigned int num, int n){
	return ~((num>>n)<<n)&num;
	//return ~((num<<n)>>n)&num;
}
unsigned int getLeftNbits(unsigned int num, int n){
	//return ~((num<<n)>>n)&num;
		return num>>(sizeof(num)*8-n);
}